package com.ruoyi.clock.service;

import com.ruoyi.clock.domain.Agent;
import com.ruoyi.clock.domain.vo.AgentVo;
import com.ruoyi.clock.domain.bo.AgentBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 代理商信息Service接口
 *
 * @author pengc
 * @date 2026-03-04
 */
public interface IAgentService {

    /**
     * 查询代理商信息分页
     *
     * @param bo 代理商信息
     * @return 代理商信息集合
     */
    TableDataInfo<AgentVo> queryPageList(AgentBo bo, PageQuery pageQuery);

    /**
     * 查询代理商信息列表
     *
     * @param bo 代理商信息
     * @return 代理商信息集合
     */
    List<AgentVo> queryList(AgentBo bo);

    /**
     * 查询代理商信息
     *
     * @param agentId 代理商信息主键
     * @return 代理商信息
     */
    AgentVo queryById(Long agentId);

    /**
     * 详情代理商信息
     *
     * @param agentId 代理商信息主键
     * @return 代理商信息
     */
    Agent loadById(Long agentId, Boolean tw);

    /**
     * 新增代理商信息
     *
     * @param bo 代理商信息
     * @return 结果
     */
    Boolean insertByBo(AgentBo bo);

    /**
     * 修改代理商信息
     *
     * @param bo 代理商信息
     * @return 结果
     */
    Boolean updateByBo(AgentBo bo);

    /**
     * 校验并批量删除代理商信息信息
     *
     * @param ids 需要删除的代理商信息主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return 结果
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 根据名称查询代理商信息
     *
     * @param agentName 代理商名称
     * @return 代理商信息
     */
    Agent getAgentByName(String agentName);


}
